#include <bits/stdc++.h>

using namespace std;

int a[200010];
int b[200010];
int seg[400010];
int pom;

int vre(int l, int d, int ind){
    if(l==d && l==pom) return 0;
    if(l==d) return b[l];
    if(l==d-1 && l==pom) return b[d];
    if(l==d-1) return b[l]+b[d];
    return vre(l,(l+d)/2,2*ind+1)+vre((l+d)/2+1,d,2*ind+2);
}

int nm(int l,int d, int ind){
    if(l==d && b[l]==1) return l;
    if(l==d) return 0;
    if(l==d-1){
        if(b[l]==1) return l;
        if(b[d]==1) return d;
        return 0;
    }
    return nm(l,(l+d)/2,2*ind+1)+nm((l+d)/2+1,d,2*ind+2);
}

void nap(int l, int d, int ind){
    if(l==d){
        seg[ind]=b[l];
        return;
    }
    if(l+1==d){
        seg[ind]=b[l]+b[d];
        return;
    }
    nap(l,(l+d)/2,2*ind+1);
    nap((l+d)/2+1,d,2*ind+2);
    seg[ind]=seg[2*ind+1]+seg[2*ind+2];
    return;
}

int main(){
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n; cin>>n;
    for(int i=0;i<n;i++) cin>>a[i];
    for(int i=1;i<n;i++) if(a[i]<a[i-1]) b[i]=1;
    //nap(0,n-1,0);
    int q; cin>>q;
    for(int i=0;i<q;i++){
        int l,d; cin>>l>>d;
        l--;d--;
        pom=l;
        if(vre(l,d,0)==0) cout<<"DA\n";
        else if(vre(l,d,0)==1){
            int ind=nm(l,d,0);
            if(ind==1||ind==l+1||(a[ind]>=a[ind-2])||ind==n-1||ind==d||(a[ind-1]<=a[ind+1])) cout<<"DA\n";
            else cout<<"NE\n";
        }
        else cout<<"NE\n";
    }
    return 0;
}